<? # KOI8-R/windows-1251 viewer version 1.01
   # Copyright Matthew Somerville 2002

Header("Content-Type: text/html; charset=utf-8");
$title = "Oregano KOI8-R/Windows-1251 viewer";

if (!ereg("Oregano",$_SERVER[HTTP_USER_AGENT]))
  finishwith("$title - Incorrect browser",'I am afraid this program is only of use (well, as far as I know) with Oregano, which can handle Unicode. Please consult the !ReadMe file that came with this program for more information.');

function finishwith($head,$body) { ?>
<html><head><title><?=$head ?></title></head>
<body>
<h1><?=$head ?></h1>
<?=$body ?></body></html><? exit; }

$self = "http://localhost/koi8r/";
$url = stripslashes($_GET[url]); $encoding = $_GET[encoding];

$form = '<form action="'.$self.'" method="get"><p>Please enter the URI (including http://) and encoding of a KOI8-R or Windows-1251 encoded page.</p><p>URI:&nbsp; <input name="url" type="text" size="40" value="'.($url ? $url : 'http://').'"> Encoding:&nbsp; <select name="encoding"><option value="koi8r">KOI8-R</option><option value="win1251">Windows-1251</option></select> <input type="submit" value="Submit"></form><p align="right">&copy; Matthew Somerville 2002<br />Web site: <a href="http://www.dracos.co.uk/riscos/programs/koi8r/">http://www.dracos.co.uk/riscos/programs/koi8r/</a><br />Email: <a href="mailto:matthew@dracos.co.uk">matthew@dracos.co.uk</a></p>';
if (!$url) finishwith($title,$form);

preg_match("/^(.*\/)(.*)$/",$url,$matches);
$dir = $matches[1]; $file = $matches[2];

$niceencs = array(koi8r => "KOI8-R", win1251 => 'Windows-1251');

if ($encoding=='koi8r') {
  $oth = 'win1251';
$map[koi8r][128]=0x2500; $map[koi8r][129]=0x2502; $map[koi8r][130]=0x250C; $map[koi8r][131]=0x2510;
$map[koi8r][132]=0x2514; $map[koi8r][133]=0x2518; $map[koi8r][134]=0x251C; $map[koi8r][135]=0x2524;
$map[koi8r][136]=0x252C; $map[koi8r][137]=0x2534; $map[koi8r][138]=0x253C; $map[koi8r][139]=0x2580;
$map[koi8r][140]=0x2584; $map[koi8r][141]=0x2588; $map[koi8r][142]=0x258C; $map[koi8r][143]=0x2590;
$map[koi8r][144]=0x2591; $map[koi8r][145]=0x2592; $map[koi8r][146]=0x2593; $map[koi8r][147]=0x2320;
$map[koi8r][148]=0x25A0; $map[koi8r][149]=0x2022; $map[koi8r][150]=0x221A; $map[koi8r][151]=0x2248;
$map[koi8r][152]=0x2264; $map[koi8r][153]=0x2265; $map[koi8r][154]=0x00A0; $map[koi8r][155]=0x2321;
$map[koi8r][156]=0x00B0; $map[koi8r][157]=0x00B2; $map[koi8r][158]=0x00B7; $map[koi8r][159]=0x00F7;
$map[koi8r][160]=0x2550; $map[koi8r][161]=0x2551; $map[koi8r][162]=0x2552; $map[koi8r][163]=0x0451;
$map[koi8r][164]=0x2553; $map[koi8r][165]=0x2554; $map[koi8r][166]=0x2555; $map[koi8r][167]=0x2556;
$map[koi8r][168]=0x2557; $map[koi8r][169]=0x2558; $map[koi8r][170]=0x2559; $map[koi8r][171]=0x255A;
$map[koi8r][172]=0x255B; $map[koi8r][173]=0x255C; $map[koi8r][174]=0x255D; $map[koi8r][175]=0x255E;
$map[koi8r][176]=0x255F; $map[koi8r][177]=0x2560; $map[koi8r][178]=0x2561; $map[koi8r][179]=0x0401;
$map[koi8r][180]=0x2562; $map[koi8r][181]=0x2563; $map[koi8r][182]=0x2564; $map[koi8r][183]=0x2565;
$map[koi8r][184]=0x2566; $map[koi8r][185]=0x2567; $map[koi8r][186]=0x2568; $map[koi8r][187]=0x2569;
$map[koi8r][188]=0x256A; $map[koi8r][189]=0x256B; $map[koi8r][190]=0x256C; $map[koi8r][191]=0x00A9;
$map[koi8r][192]=0x044E; $map[koi8r][193]=0x0430; $map[koi8r][194]=0x0431; $map[koi8r][195]=0x0446;
$map[koi8r][196]=0x0434; $map[koi8r][197]=0x0435; $map[koi8r][198]=0x0444; $map[koi8r][199]=0x0433;
$map[koi8r][200]=0x0445; $map[koi8r][201]=0x0438; $map[koi8r][202]=0x0439; $map[koi8r][203]=0x043A;
$map[koi8r][204]=0x043B; $map[koi8r][205]=0x043C; $map[koi8r][206]=0x043D; $map[koi8r][207]=0x043E;
$map[koi8r][208]=0x043F; $map[koi8r][209]=0x044F; $map[koi8r][210]=0x0440; $map[koi8r][211]=0x0441;
$map[koi8r][212]=0x0442; $map[koi8r][213]=0x0443; $map[koi8r][214]=0x0436; $map[koi8r][215]=0x0432;
$map[koi8r][216]=0x044C; $map[koi8r][217]=0x044B; $map[koi8r][218]=0x0437; $map[koi8r][219]=0x0448;
$map[koi8r][220]=0x044D; $map[koi8r][221]=0x0449; $map[koi8r][222]=0x0447; $map[koi8r][223]=0x044A;
$map[koi8r][224]=0x042E; $map[koi8r][225]=0x0410; $map[koi8r][226]=0x0411; $map[koi8r][227]=0x0426;
$map[koi8r][228]=0x0414; $map[koi8r][229]=0x0415; $map[koi8r][230]=0x0424; $map[koi8r][231]=0x0413;
$map[koi8r][232]=0x0425; $map[koi8r][233]=0x0418; $map[koi8r][234]=0x0419; $map[koi8r][235]=0x041A;
$map[koi8r][236]=0x041B; $map[koi8r][237]=0x041C; $map[koi8r][238]=0x041D; $map[koi8r][239]=0x041E;
$map[koi8r][240]=0x041F; $map[koi8r][241]=0x042F; $map[koi8r][242]=0x0420; $map[koi8r][243]=0x0421;
$map[koi8r][244]=0x0422; $map[koi8r][245]=0x0423; $map[koi8r][246]=0x0416; $map[koi8r][247]=0x0412;
$map[koi8r][248]=0x042C; $map[koi8r][249]=0x042B; $map[koi8r][250]=0x0417; $map[koi8r][251]=0x0428;
$map[koi8r][252]=0x042D; $map[koi8r][253]=0x0429; $map[koi8r][254]=0x0427; $map[koi8r][255]=0x042A;

} elseif ($encoding == 'win1251') {
  $oth = 'koi8r';
$map[win1251][128]=0x0402; $map[win1251][129]=0x0403; $map[win1251][130]=0x201A; $map[win1251][131]=0x0453;
$map[win1251][132]=0x201E; $map[win1251][133]=0x2026; $map[win1251][134]=0x2020; $map[win1251][135]=0x2021;
$map[win1251][136]=0x20AC; $map[win1251][137]=0x2030; $map[win1251][138]=0x0409; $map[win1251][139]=0x2039;
$map[win1251][140]=0x040A; $map[win1251][141]=0x040C; $map[win1251][142]=0x040B; $map[win1251][143]=0x040F;
$map[win1251][144]=0x0452; $map[win1251][145]=0x2018; $map[win1251][146]=0x2019; $map[win1251][147]=0x201C;
$map[win1251][148]=0x201D; $map[win1251][149]=0x2022; $map[win1251][150]=0x2013; $map[win1251][151]=0x2014;
$map[win1251][153]=0x2122; $map[win1251][154]=0x0459; $map[win1251][155]=0x203A; $map[win1251][156]=0x045A;
$map[win1251][157]=0x045C; $map[win1251][158]=0x045B; $map[win1251][159]=0x045F; $map[win1251][160]=0x00A0;
$map[win1251][161]=0x040E; $map[win1251][162]=0x045E; $map[win1251][163]=0x0408; $map[win1251][164]=0x00A4;
$map[win1251][165]=0x0490; $map[win1251][166]=0x00A6; $map[win1251][167]=0x00A7; $map[win1251][168]=0x0401;
$map[win1251][169]=0x00A9; $map[win1251][170]=0x0404; $map[win1251][171]=0x00AB; $map[win1251][172]=0x00AC;
$map[win1251][173]=0x00AD; $map[win1251][174]=0x00AE; $map[win1251][175]=0x0407; $map[win1251][176]=0x00B0;
$map[win1251][177]=0x00B1; $map[win1251][178]=0x0406; $map[win1251][179]=0x0456; $map[win1251][180]=0x0491;
$map[win1251][181]=0x00B5; $map[win1251][182]=0x00B6; $map[win1251][183]=0x00B7; $map[win1251][184]=0x0451;
$map[win1251][185]=0x2116; $map[win1251][186]=0x0454; $map[win1251][187]=0x00BB; $map[win1251][188]=0x0458;
$map[win1251][189]=0x0405; $map[win1251][190]=0x0455; $map[win1251][191]=0x0457; $map[win1251][192]=0x0410;
$map[win1251][193]=0x0411; $map[win1251][194]=0x0412; $map[win1251][195]=0x0413; $map[win1251][196]=0x0414;
$map[win1251][197]=0x0415; $map[win1251][198]=0x0416; $map[win1251][199]=0x0417; $map[win1251][200]=0x0418;
$map[win1251][201]=0x0419; $map[win1251][202]=0x041A; $map[win1251][203]=0x041B; $map[win1251][204]=0x041C;
$map[win1251][205]=0x041D; $map[win1251][206]=0x041E; $map[win1251][207]=0x041F; $map[win1251][208]=0x0420;
$map[win1251][209]=0x0421; $map[win1251][210]=0x0422; $map[win1251][211]=0x0423; $map[win1251][212]=0x0424;
$map[win1251][213]=0x0425; $map[win1251][214]=0x0426; $map[win1251][215]=0x0427; $map[win1251][216]=0x0428;
$map[win1251][217]=0x0429; $map[win1251][218]=0x042A; $map[win1251][219]=0x042B; $map[win1251][220]=0x042C;
$map[win1251][221]=0x042D; $map[win1251][222]=0x042E; $map[win1251][223]=0x042F; $map[win1251][224]=0x0430;
$map[win1251][225]=0x0431; $map[win1251][226]=0x0432; $map[win1251][227]=0x0433; $map[win1251][228]=0x0434;
$map[win1251][229]=0x0435; $map[win1251][230]=0x0436; $map[win1251][231]=0x0437; $map[win1251][232]=0x0438;
$map[win1251][233]=0x0439; $map[win1251][234]=0x043A; $map[win1251][235]=0x043B; $map[win1251][236]=0x043C;
$map[win1251][237]=0x043D; $map[win1251][238]=0x043E; $map[win1251][239]=0x043F; $map[win1251][240]=0x0440;
$map[win1251][241]=0x0441; $map[win1251][242]=0x0442; $map[win1251][243]=0x0443; $map[win1251][244]=0x0444;
$map[win1251][245]=0x0445; $map[win1251][246]=0x0446; $map[win1251][247]=0x0447; $map[win1251][248]=0x0448;
$map[win1251][249]=0x0449; $map[win1251][250]=0x044A; $map[win1251][251]=0x044B; $map[win1251][252]=0x044C;
$map[win1251][253]=0x044D; $map[win1251][254]=0x044E; $map[win1251][255]=0x044F;
} else {
  finishwith("$title - Illegal encoding","<em>An illegal encoding has been specified.</em><hr>$form");
}

foreach ($map as $encoding => $array)
  foreach($array as $key => $value)
    $map[$encoding][$key] = '&#'.$value.';';

$file = @file($url);
if (!$file) {
  finishwith("$title - No webpage fetched","<em>The webpage could not be fetched - please check the URI and that you are connected to the internet.</em><hr>$form");
}

$d = join("",$file);

function preghandler($a,$b,$c,$d,$e) {
  global $encoding;
  return stripslashes("<$a$b"."$c=$d").rel(stripslashes($e),$encoding).stripslashes($d);
}

$d = preg_replace("/<head>/i","<head><base href=\"$url\">",$d);
$d = preg_replace("/[\x80-\xff]/e",'$map[$encoding][ord(\\0)]',$d);
$d = preg_replace('/<(a|link)([^>]*?)href=("|\'|)([^> ]*)\3/sie',"preghandler('\\1','\\2','href','\\3','\\4')",$d);
$d = preg_replace('/<frame([^>]*?)src=("|\'|)([^ >]*)\2/ise',"preghandler('frame','\\1','src','\\2','\\3')",$d);

$banner = '<table cellpadding="3" cellspacing="0" border="1" bgcolor="#ffffff"><tr><td align="center" colspan="3" style="color: #000000"><big>This is a converted version of <a href="'.$url.'">'.$url.'</a>, converting all '.$niceencs[$encoding].' characters to their Unicode equivalents to try and enable you to view the page with Oregano.</big></td></tr>
<tr><td align="left" style="color: #000000">If the page still appears wrongly, try switching to <a href="'.rel($url,$oth).'">'.$niceencs[$oth].'</a></td><td style="color: #000000" align="center"><a href="'.$self.'">Enter new URL</a></td><td style="color: #000000" align="right"><a href="mailto:matthew@dracos.co.uk">Comments or queries</a></td></tr></table><br />';

$d = preg_replace("/<body.*?>/si","\\0$banner",$d);
print $d;

function rel($to,$enc) {
  global $dir,$self;
  if (eregi("^http://",$to)) return $self.'?encoding='.$enc.'&amp;url='.urlencode($to);
  if (eregi("^(mailto|javascript):",$to)) return $to;
  if (eregi("(txt|gif|pdf|jpg|jpeg)$",$to)) return $to;
  return $self.'?encoding='.$enc.'&amp;url='.urlencode("$dir$to");
}
?>
